import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Game_Jam_Boss_Dungeon extends PApplet {

Player james;
Snake serp;
BallChase mace;
Sword sam;
GreenWolf greenDog;

int[] deadBoss = new int[3];
PImage[] cauldron = new PImage[8];
PImage cauldronCurrent;

int screenNumber;
boolean up = false;
boolean down = false;
boolean left = false;
boolean right = false;
boolean hitWallUp = false;
boolean hitWallDown = false;
boolean hitWallLeft = false;
boolean hitWallRight = false;
boolean hitWallUpBoss = false;
boolean hitWallDownBoss = false;
boolean hitWallLeftBoss = false;
boolean hitWallRightBoss = false;

boolean canAttackUp = true;
boolean canAttackDown = true;
boolean canAttackLeft = true;
boolean canAttackRight = true;

boolean attackUp = false;
boolean attackDown = false;
boolean attackLeft = false;
boolean attackRight = false;
int attackTimerMax;
int attackTimerUp;
int attackTimerDown;
int attackTimerLeft;
int attackTimerRight;
int gotHit;

boolean snakeDead = false;
boolean spikeDead = false;
boolean samDead = false;
boolean finalBossDead = false;
boolean gameOver = false;
boolean gameWon = false;

int finalBossSpawn;

PImage Dungon;
PImage Cauldron;
PImage Spike;


int northDoorX;
int northDoorY;
int northDoorWidth;
int northDoorHeight;
int eastDoorX;
int eastDoorY;
int eastDoorWidth;
int eastDoorHeight;
int southDoorX;
int southDoorY;
int southDoorWidth;
int southDoorHeight;
int westDoorX;
int westDoorY;
int westDoorWidth;
int westDoorHeight;

float startX;
float startY;
float startW;
float startH;
PImage startButton;
PImage Title;
float resetW;
float resetH;
float resetX;
float resetY;
PImage GameOver;
PImage WinScreen;

public void setup() {
  
  james = new Player();
  serp = new Snake();
  mace = new BallChase();
  sam = new Sword();
  greenDog = new GreenWolf();

  for (int i = 0; i<3; i++) {
    deadBoss[i] = -1;
  }

  attackTimerMax = 60;

  northDoorX = width/2-25;
  northDoorY = 0;
  northDoorWidth = 50;
  northDoorHeight = 15;
  eastDoorX = width-10;
  eastDoorY = height/2-25;
  eastDoorWidth = 15;
  eastDoorHeight = 50;
  southDoorX = width/2-25;
  southDoorY = height-10;
  southDoorWidth = 50;
  southDoorHeight = 15;
  westDoorX = 0;
  westDoorY = height/2-25;
  westDoorWidth = 10;
  westDoorHeight = 50;

  startX = 308;
  startY = 428;
  startW = 133;
  startH = 22;
  startButton = loadImage("StartButton.png");
  Title = loadImage("TitleScreen.png");
  GameOver = loadImage("GameOver.png");
  WinScreen = loadImage("WinScreen.png");
  resetW = 188;
  resetH = 22;
  resetX = 281;
  resetY = 428;

  screenNumber = 1;
  Dungon = loadImage("Dungon.png");
  Spike = loadImage("spike.png");

  finalBossSpawn = 0;
}

public void draw() {
  if (gameOver == false && gameWon == false) {

    if (screenNumber == 1) {
      imageMode(CORNER);
      image(Title, 0, 0);
    }

    //Main Room
    if (screenNumber == 2) {
      background(255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      if (deadBoss[0] == -1 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_s.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 2 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_ts.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 3 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_te.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 2 && deadBoss[2] == 3) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 1 && deadBoss[1] == 3 && deadBoss[2] == 2) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_t.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_ts.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 3 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_te.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 3 && deadBoss[2] == 1) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 2 && deadBoss[1] == 1 && deadBoss[2] == 3) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == -1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_e.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 1 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_se.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 2 && deadBoss[2] == -1) {
        cauldronCurrent = loadImage("cauldron_te.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 2 && deadBoss[2] == 1) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      if (deadBoss[0] == 3 && deadBoss[1] == 1 && deadBoss[2] == 2) {
        cauldronCurrent = loadImage("cauldron_all.png");
      }
      imageMode(CENTER);
      image(cauldronCurrent, width/2, 100);
      james.drawPlayer();
      james.updatePlayer();
      fill(152, 104, 40);
      rect(eastDoorX, eastDoorY, eastDoorWidth, eastDoorHeight);
      rect(southDoorX, southDoorY, southDoorWidth, southDoorHeight);
      rect(westDoorX, westDoorY, westDoorWidth, westDoorHeight);
      if (james.x > eastDoorX && james.x < eastDoorX+eastDoorWidth && james.y > eastDoorY && james.y < eastDoorY+eastDoorHeight && screenNumber == 2 && spikeDead == false) {
        screenNumber = 3;
        james.resetPlayerLeft();
      }
      if (james.x > southDoorX && james.x < southDoorX+southDoorWidth && james.y > southDoorY && james.y < southDoorY+southDoorHeight && screenNumber == 2 && snakeDead==false) {
        screenNumber = 4;
        james.resetPlayerTop();
      }
      if (james.x > westDoorX && james.x < westDoorX+westDoorWidth && james.y > westDoorY && james.y < westDoorY+westDoorHeight && screenNumber == 2 && samDead == false) {
        screenNumber = 5;
        james.resetPlayerRight();
      }
      if (snakeDead == true && spikeDead == true && samDead == true) {
        finalBossSpawn++;
        if (finalBossSpawn>=0 && finalBossSpawn<300) {
          textAlign(CENTER);
          textSize(20);
          fill(0);
          text("You have done well to make it this far.", width/2, height/2-5);
        }
        if (finalBossSpawn>=300 && finalBossSpawn<600) {
          textAlign(CENTER);
          textSize(20);
          fill(0);
          text("But the journey so far has been child's play", width/2, height/2-5);
          text("compared to what's to come.", width/2, height/2+17);
        }
        if (finalBossSpawn>=600 && finalBossSpawn<900) {
          textAlign(CENTER);
          textSize(20);
          fill(0);
          text("Now you face your greatest challenge!", width/2, height/2-5);
        }
        if (finalBossSpawn>=900 && finalBossDead == false) {
          greenDog.drawFinal();
          greenDog.updateFinal();
          gotHit--;
          float distancePlayerF = dist(james.x, james.y, greenDog.x, greenDog.y);
          if (distancePlayerF<greenDog.finalSize/2 && gotHit<=0) {
            james.health-=greenDog.power;
            gotHit = 120;
          }
          float distanceThrustF = dist(james.swordX, james.swordY, greenDog.x, greenDog.y);
          if (distanceThrustF < 60 && attackUp == true) {
            greenDog.health-=james.swordPower;
            attackUp = false;
          }
          if (distanceThrustF < 60 && attackDown == true) {
            greenDog.health-=james.swordPower;
            attackDown = false;
          }
          if (distanceThrustF < 60 && attackLeft == true) {
            greenDog.health-=james.swordPower;
            attackLeft = false;
          }
          if (distanceThrustF < 60 && attackRight == true) {
            greenDog.health-=james.swordPower;
            attackRight = false;
          }

          if (greenDog.health<=0) {
            finalBossDead = true;
          }
        }
        if (finalBossSpawn>=900 && finalBossDead == true) {
          gameWon = true;
        }
      }
    }
    //Room to the right Mace Man
    if (screenNumber == 3) {
      background (0, 0, 255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      if (mace.health>0) {
        mace.drawBall();
        mace.updateBallXneo();
      }
      if (mace.health<=0 && spikeDead == false) {
        mace.clearBody();
        spikeDead = true;
        for (int i = 0; i<3; i++) {
          if (deadBoss[i] == -1) {
            deadBoss[i] = mace.bossID;
            println(deadBoss[0]);
            break;
          }
        }
      }
      james.drawPlayer();
      james.updatePlayer();

      fill(0);
      rect(westDoorX, westDoorY, 10, 50);
      if (james.x > westDoorX && james.x < westDoorX+westDoorWidth && james.y > westDoorY && james.y < westDoorY+westDoorHeight && screenNumber == 3 && spikeDead == true) {
        screenNumber = 2;
        james.health = 100;
        james.resetPlayerRight();
      }
      gotHit--;
      float distancePlayerS = dist(james.x, james.y, mace.x, mace.y);
      if (distancePlayerS<58 && gotHit<=0) {
        james.health-=mace.power;
        gotHit = 120;
      }
      float distanceThrustS = dist(james.swordX, james.swordY, mace.x, mace.y);
      if (distanceThrustS < 60 && attackUp == true) {
        println("You hit the Spike Up");
        mace.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrustS < 60 && attackDown == true) {
        println("You hit the Spike Down");
        mace.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrustS < 60 && attackLeft == true) {
        println("You hit the Spike Left");
        mace.health-=james.swordPower;
        attackLeft = false;
      }
      if (distanceThrustS < 60 && attackRight == true) {
        println("You hit the Spike Right");
        mace.health-=james.swordPower;
        attackRight = false;
      }
    }
    //This is the snake boss room
    if (screenNumber == 4) {
      background (255, 0, 255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      fill(0, 255, 0);
      if (serp.health>0) {
        serp.drawSnake();
        serp.updateSnake();
      }
      if (serp.health<=0 && snakeDead == false) {
        serp.clearBody();
        snakeDead = true;
        for (int i = 0; i<3; i++) {
          if (deadBoss[i] == -1) {
            deadBoss[i] = serp.bossID;
            println(deadBoss[0]);
            break;
          }
        }
      }
      james.drawPlayer();
      james.updatePlayer();
      fill(0);
      rect(northDoorX, northDoorY, northDoorWidth, northDoorHeight);
      if (james.x > northDoorX && james.x < northDoorX+northDoorWidth && james.y > northDoorY && james.y < northDoorY+northDoorHeight && screenNumber == 4 && snakeDead == true) {
        screenNumber = 2;
        james.health = 100;
        james.resetPlayerBottom();
      }
      gotHit--;
      float distancePlayer = dist(james.x, james.y, serp.SnakeHeadX, serp.SnakeHeadY);
      if (distancePlayer<38 && gotHit<=0) {
        james.health-=serp.power;
        gotHit = 120;
      }
      float distanceThrustH = dist(james.swordX, james.swordY, serp.SnakeHeadX, serp.SnakeHeadY);
      if (distanceThrustH < 60 && attackUp == true) {
        println("You hit the snake Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrustH < 60 && attackDown == true) {
        println("You hit the snake Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrustH < 60 && attackLeft == true) {
        println("You hit the snake Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrustH < 60 && attackRight == true) {
        println("You hit the snake Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust1 = dist(james.swordX, james.swordY, serp.SnakeBody1X, serp.SnakeBody1Y);
      if (distanceThrust1 < 45 && attackUp == true) {
        println("You hit the snake body 1 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust1 < 45 && attackDown == true) {
        println("You hit the snake body 1 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust1 < 45 && attackLeft == true) {
        println("You hit the snake body 1 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust1 < 45 && attackRight == true) {
        println("You hit the snake body 1 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust2 = dist(james.swordX, james.swordY, serp.SnakeBody2X, serp.SnakeBody2Y);
      if (distanceThrust2 < 45 && attackUp == true) {
        println("You hit the snake body 2 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust2 < 45 && attackDown == true) {
        println("You hit the snake body 2 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust2 < 45 && attackLeft == true) {
        println("You hit the snake body 2 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust2 < 45 && attackRight == true) {
        println("You hit the snake body 2 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust3 = dist(james.swordX, james.swordY, serp.SnakeBody3X, serp.SnakeBody3Y);
      if (distanceThrust2 < 45 && attackUp == true) {
        println("You hit the snake body 3 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust3 < 45 && attackDown == true) {
        println("You hit the snake body 3 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust3 < 45 && attackLeft == true) {
        println("You hit the snake body 3 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust3 < 45 && attackRight == true) {
        println("You hit the snake body 3 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
      float distanceThrust4 = dist(james.swordX, james.swordY, serp.SnakeBody4X, serp.SnakeBody4Y);
      if (distanceThrust2 < 45 && attackUp == true) {
        println("You hit the snake body 4 Up");
        serp.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrust4 < 45 && attackDown == true) {
        println("You hit the snake body 4 Down");
        serp.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrust4 < 45 && attackLeft == true) {
        println("You hit the snake body 4 Left");
        serp.health-=james.swordPower;
        attackLeft = false;
      }  
      if (distanceThrust4 < 45 && attackRight == true) {
        println("You hit the snake body 4 Right");
        serp.health-=james.swordPower;
        attackRight = false;
      }
    }
    if (screenNumber == 5) {
      background (0, 255, 255);
      imageMode(CORNER);
      image(Dungon, 0, 0);
      fill(0);
      if (sam.health>0) {
        sam.drawSword();
        sam.updateSword();
      }
      if (sam.health<=0 && samDead == false) {
        sam.clearBody();
        samDead = true;
        for (int i = 0; i<3; i++) {
          if (deadBoss[i] == -1) {
            deadBoss[i] = sam.bossID;
            println(deadBoss[0]);
            break;
          }
        }
      }
      gotHit--;
      float distancePlayerSam = dist(james.x, james.y, sam.x, sam.y);
      if (distancePlayerSam<90 && gotHit<=0 && sam.killZone ==true) {
        james.health-=sam.power;
        println(sam.attackTime);
        gotHit = 120;
      }
      float distanceThrustSam = dist(james.swordX, james.swordY, sam.x, sam.y);
      if (distanceThrustSam < 80 && attackUp == true) {
        println("You hit the sam Up");
        sam.health-=james.swordPower;
        attackUp = false;
      }
      if (distanceThrustSam < 80 && attackDown == true) {
        println("You hit the sam Down");
        sam.health-=james.swordPower;
        attackDown = false;
      }
      if (distanceThrustSam < 80 && attackLeft == true) {
        println("You hit the sam Left");
        sam.health-=james.swordPower;
        attackLeft = false;
      }
      if (distanceThrustSam < 80 && attackRight == true) {
        println("You hit the sam Right");
        sam.health-=james.swordPower;
        attackRight = false;
      }
      james.drawPlayer();
      james.updatePlayer();
      fill(0);
      rect(eastDoorX, eastDoorY, eastDoorWidth, eastDoorHeight);
      if (james.x > eastDoorX && james.x < eastDoorX+eastDoorWidth && james.y > eastDoorY && james.y < eastDoorY+eastDoorHeight && screenNumber == 5 && samDead == true) {
        screenNumber = 2;
        james.health = 100;
        james.resetPlayerLeft();
      }
    }

    attackTimerUp--;
    attackTimerDown--;
    attackTimerLeft--;
    attackTimerRight--;

    if (attackTimerUp <=0) {
      attackUp = false;
    }
    if (attackTimerDown <=0) {
      attackDown = false;
    }
    if (attackTimerLeft <=0) {
      attackLeft = false;
    }
    if (attackTimerRight <=0) {
      attackRight = false;
    }
  }
  if (gameOver == true) {
    imageMode(CORNER);
    image(GameOver, 0, 0);
  }
  if (gameWon == true) {
    imageMode(CORNER);
    image(WinScreen, 0, 0);
  }
  if (attackTimerUp<=0) {
    canAttackUp = true;
  }
  if (attackTimerDown<=0) {
    canAttackDown = true;
  }
  if (attackTimerLeft<=0) {
    canAttackLeft = true;
  }
  if (attackTimerRight<=0) {
    canAttackRight= true;
  }
}


public void keyPressed() {
  if (key == 'w') {
    up = true;
  }
  if (key == 's') {
    down = true;
  }
  if (key == 'a') {
    left = true;
  }
  if (key == 'd') {
    right = true;
  }
  if (keyCode == UP && canAttackUp == true) {
    attackUp = true;
    canAttackUp = false;
    attackTimerUp = attackTimerMax;
  }
  if (keyCode == DOWN && canAttackDown == true) {
    attackDown = true;
    canAttackDown = false;
    attackTimerDown = attackTimerMax;
  }
  if (keyCode == LEFT && canAttackLeft == true) {
    attackLeft = true;
    canAttackLeft = false;
    attackTimerLeft = attackTimerMax;
  }
  if (keyCode == RIGHT && canAttackRight == true) {
    attackRight = true;
    canAttackRight = false;
    attackTimerRight = attackTimerMax;
  }
}

public void keyReleased() {
  if (key == 'w') {
    up = false;
  }
  if (key == 's') {
    down = false;
  }
  if (key == 'a') {
    left = false;
  }
  if (key == 'd') {
    right = false;
  }
  if (keyCode == UP && attackTimerUp<=0) {
    canAttackUp = true;
  }
  if (keyCode == DOWN && attackTimerDown<=0) {
    canAttackDown = true;
  }
  if (keyCode == LEFT && attackTimerLeft<=0) {
    canAttackLeft = true;
  }
  if (keyCode == RIGHT && attackTimerRight<=0) {
    canAttackRight = true;
  }
}

public void mousePressed() {
  if (mouseX > startX && mouseX < startX+startW && mouseY > startY&& mouseY < startY+startH && screenNumber == 1) {
    screenNumber = 2;
  }
  if (mouseX > resetX && mouseX < resetX+resetW && mouseY > resetY&& mouseY < resetY+resetH && gameOver == true) {
    gameOver = false;
    screenNumber = 1;
    spikeDead = false;
    snakeDead = false;
    samDead = false;
    james.reset();
    mace.reset();
    serp.reset();
    sam.reset();
    greenDog.reset();
    for (int i = 0; i<3; i++) {
      deadBoss[i] = -1;
    }
  }
  if (mouseX > resetX && mouseX < resetX+resetW && mouseY > resetY&& mouseY < resetY+resetH && gameWon == true) {
    gameWon = false;
    screenNumber = 1;
    spikeDead = false;
    snakeDead = false;
    samDead = false;
    finalBossDead = false;
    finalBossSpawn =0;
    james.reset();
    mace.reset();
    serp.reset();
    sam.reset();
    greenDog.reset();
    for (int i = 0; i<3; i++) {
      deadBoss[i] = -1;
    }
  }
}
class BallChase {

  float xneoBall = .02f;// only for xneo

  float x = width-90;
  float y = height/2;
  float health = 250;
  float hisBodyToYou;
  float power = 10;
  float swordToHead;
  float deadX;
  float deadY;
  int bossID = 1;
  

  boolean youHitHim;
  boolean heHitYou;

  public void drawBall() {
    imageMode(CENTER);
    image(Spike, x, y);
  }


  public void updateBallXneo() {

    x = x * (1 - xneoBall)+ james.x * xneoBall;
    y = y * (1 - xneoBall)+ james.y * xneoBall;
    fill(255, 0, 0);
    rect(10, height-30, health, 20);

    /*swordToHead = dist(james.swordX, james.swordY, BallX, BallY - 50);
     if (swordToHead<= 42 && attackUp == true){
     
     youHitHim = true;
     }
     if (youHitHim == true){
     BallHealth =- james.swordPower;
     youHitHim = false;
     }*/
  }
  public void clearBody(){
    x = deadX;
    y = deadY;
  }
  public void reset(){
    x = width-90;
    y = height/2;
    health = 250;
  }
}
class GreenWolf {

  float xneoFinal = .01f;
  float x = width/2;
  float y = 100;
  float finalSize = 100;
  float speedFinal = 5;

  float inAttackRang;
  float attackRange = 20;
  float timeSinceLastAttack = 30;
  float attackOver = 121;
  float power = 20;


  float attackTimer = 0;
  float attackStance = 0;

  boolean isAttacking;
  boolean inRange;

  float health = 300;
  PImage GreenDog = loadImage("GreenDog.png");

  public void drawFinal() {
    imageMode(CENTER);
    image(GreenDog, x, y);
    fill(255, 0, 0);
    rect(10, height-30, health, 20);
  }

  public void updateFinal() {

    x = x * (1 - xneoFinal)+ james.x * xneoFinal;
    y = y * (1 - xneoFinal)+ james.y * xneoFinal;
    timeSinceLastAttack = timeSinceLastAttack + 1;
    println(timeSinceLastAttack);

    float inAttackRang = dist( x, y, james.x, james.y);

    if (inAttackRang < (finalSize/2)+ attackRange && timeSinceLastAttack > 180) {// 
      inRange = true;
    }
    if (attackStance<120) {
      GreenDog = loadImage("GreenDog.png");
    }

    if (inRange ==true) {
      xneoFinal = 0;

      attackTimer = attackTimer + 1;
      println(attackTimer);
      attackStance++;
      if (attackTimer >= 120) {
        if (attackStance>=120) {
          GreenDog = loadImage("GreenDogAtk.png");
        }
        if (attackStance>=180) {
          attackStance = attackTimer;
        }
        //fill(255, 0, 0);
        //attackRadius = attackRadius + 2;
        //ellipse(x, y, attackRadius, attackRadius);
        finalSize = 200;
        isAttacking = true;
        if (attackTimer > attackOver) {
          attackStance =0;
          inRange = false; 
          finalSize = 100;
          attackTimer =0;
          timeSinceLastAttack = 0;
          isAttacking = false;
        }
      }
    } else {
      xneoFinal = .01f;
    }
  }
  public void reset() {
    health = 300;
    x = width/2;
    y = 100;
    attackTimer = 0;
    attackOver = 0;
  }
}
class Player {
  float x = width/2;
  float y = height/2;
  float size = 25;
  float speed = 4;
  float playerX;
  float playerY;
  float health = 100;
  float swordX;
  float swordY;
  float swordPower = 15;
  PImage Player = loadImage("PlayerDown.png");
  PImage swordUp = loadImage("SwordUp.png");
  PImage swordDown = loadImage("SwordDown.png");
  PImage swordLeft = loadImage("SwordLeft.png");
  PImage swordRight = loadImage("SwordRight.png");


  public void drawPlayer() {
    fill(0,0,255);
    rect(10,10,health,20);
    imageMode(CENTER);
    image(Player,x,y);
    playerX = x;
    playerY = y;
  }

  public void updatePlayer() {

    if (x <=0) {
      hitWallLeft = true;
    } else {
      hitWallLeft = false;
    }
    if (x>=width) {
      hitWallRight = true;
    } else {
      hitWallRight = false;
    }
    if (y<=0) {
      hitWallUp = true;
    } else {
      hitWallUp = false;
    }
    if (y>=height) {
      hitWallDown = true;
    } else {
      hitWallDown = false;
    }

    if (up == true && hitWallUp == false) {
      Player = loadImage("PlayerUp.png");
      y -=speed;
    }
    if (down == true && hitWallDown == false) {
      Player = loadImage("PlayerDown.png");
      y += speed;
    }
    if (left == true && hitWallLeft == false) {
      Player = loadImage("PlayerLeft.png");
      x -=speed;
    }
    if (right == true && hitWallRight == false) {
      Player = loadImage("PlayerRight.png");
      x +=speed;
    }
    if (attackTimerUp>30) {
      //println("Hit"+ attackTimerUp);
      swordX = x-5;
      swordY = y-40;
      imageMode(CORNER);
      image(swordUp,swordX,swordY);
      //rect(swordX, swordY, 10, 20);
    }
    if (attackTimerDown>30) {
      //println("Hit"+ attackTimerDown);
      swordX = x-5;
      swordY = y+10;
      imageMode(CORNER);
      image(swordDown,swordX,swordY-5);
      //rect(swordX, swordY, 10, 20);
    }
    if (attackTimerLeft>30) {
      //println("Hit"+ attackTimerLeft);
      swordX = x-25;
      swordY = y;
      image(swordLeft,swordX,swordY);
      //rect(swordX, swordY, 20, 10);
    }
    if (attackTimerRight>30) {
      //println("Hit"+ attackTimerRight);
      swordX = x+25;
      swordY = y;
      image(swordRight,swordX,swordY);
      //rect(swordX, swordY, 20, 10);
    }
    
    if(health<=0){
      gameOver = true;
    }
  }

  public void resetPlayerLeft() {
    x = 30;
    y = height/2;
  }
  public void resetPlayerRight() {
    x = width-30;
    y = height/2;
  }
  public void resetPlayerTop() {
    x = width/2;
    y = 30;
  }
  public void resetPlayerBottom() {
    x = width/2;
    y = height-30;
  }
  
  public void reset(){
    x= width/2;
    y = height/2;
    health = 100;
    gotHit = 0;
  }
}
class Snake {

  float SnakeHeadX = width/2;
  float SnakeHeadY = height/2;
  float SnakeHeadSize = 50;
  float SnakeBody1X = SnakeHeadX;
  float SnakeBody1Y = SnakeHeadY;
  float SnakeBody2X = SnakeHeadX;
  float SnakeBody2Y = SnakeHeadY;
  float SnakeBody3X = SnakeHeadX;
  float SnakeBody3Y = SnakeHeadY;
  float SnakeBody4X = SnakeHeadX;
  float SnakeBody4Y = SnakeHeadY;
  float SnakeBodySize = 25;
  float SnakeMoveX = -3;
  float SnakeMoveY ;//= 3;
  float health = 300;
  float power = 15;
  float deadX = 1500;
  float deadY = 1500;
  PImage SnakeFace;
  PImage SnakeBody;
  
  float normSlopeX;
  float normSlopeY;

  float targetX;
  float targetY;
  float slopeX;
  float slopeY;
  float equilizer;

  float xneo = 0.05f;
  float xneo2 = .15f;
  
  int bossID = 2;

  public void drawSnake() {
    fill(255,0,0);
    rect(10,height-30,health,20);
    fill(0);
    // draw snake
    SnakeBody = loadImage("SnakeBody.png");
    imageMode(CENTER);
    image(SnakeBody,SnakeBody4X,SnakeBody4Y);
    image(SnakeBody,SnakeBody3X,SnakeBody3Y);
    image(SnakeBody,SnakeBody2X,SnakeBody2Y);
    image(SnakeBody,SnakeBody1X,SnakeBody1Y);
    SnakeFace = loadImage("SnakeFace.png");
    imageMode(CENTER);
    image(SnakeFace, SnakeHeadX, SnakeHeadY);
    
    // moving snake
    SnakeHeadX = SnakeHeadX + SnakeMoveX;
    SnakeHeadY = SnakeHeadY + SnakeMoveY;
    // xneo fallow the leader
    SnakeBody1X = SnakeBody1X * (1 - xneo2)+ SnakeHeadX * xneo2;
    SnakeBody1Y = SnakeBody1Y * (1 - xneo2)+ SnakeHeadY * xneo2;
    SnakeBody2X = SnakeBody2X * (1 - xneo2 )+ SnakeBody1X * xneo2 ;
    SnakeBody2Y = SnakeBody2Y * (1 - xneo2 )+ SnakeBody1Y * xneo2 ;
    SnakeBody3X = SnakeBody3X * (1 - xneo2 )+ SnakeBody2X * xneo2 ;
    SnakeBody3Y = SnakeBody3Y * (1 - xneo2 )+ SnakeBody2Y * xneo2 ;
    SnakeBody4X = SnakeBody4X * (1 - xneo2 )+ SnakeBody3X * xneo2 ;
    SnakeBody4Y = SnakeBody4Y * (1 - xneo2 )+ SnakeBody3Y * xneo2 ;
  }


  public void updateSnake() {
    if (SnakeHeadX >= width - (SnakeHeadSize/2)) {
      hitWallRightBoss = true;
      //println("HitRight");
    } else {
      hitWallRightBoss = false;
    }

    if (SnakeHeadX <= 0 + (SnakeHeadSize/2)) {
      hitWallLeftBoss = true;
      //println("hitLeft");
    } else {
      hitWallLeftBoss = false;
    }

    if (SnakeHeadY >= height - (SnakeHeadSize/2)) {
      hitWallDownBoss = true;
      //println("hit bot");
    } else {
      hitWallDownBoss = false;
    }

    if (SnakeHeadY <= 0 + (SnakeHeadSize/2)) {
      hitWallUpBoss =true;
      //println("hit top");
    } else {
      hitWallUpBoss = false;
    }
    //\/\/\/\/\/\/\/\\/\/\/\/\/\/ 
    if (hitWallRightBoss == true) {
      targetX = james.x;
      targetY = james.y;
      math();
      hitWallRightBoss =false;
    }
    if (hitWallLeftBoss == true) {
      targetX = james.x;
      targetY = james.y;
      math();
      hitWallLeftBoss = false;
    }
    if (hitWallUpBoss == true) {
      targetX = james.x;
      targetY = james.y;
      math();
      hitWallUpBoss = false;
    }
    if (hitWallDownBoss == true) {
      targetX = james.x;
      targetY = james.y;
      math();
      hitWallDownBoss = false;
    }
  }// end of update snake

  public void math() {

    slopeX = targetX - SnakeHeadX;
    slopeY = targetY - SnakeHeadY;

    normSlopeX = slopeX / (abs(slopeX)+abs(slopeY));
    normSlopeY = slopeY / (abs(slopeX)+abs(slopeY));

    SnakeMoveX = normSlopeX * 6;
    SnakeMoveY = normSlopeY * 6;
  }
  public void clearBody() {
    SnakeHeadX = deadX;
    SnakeHeadY = deadY;
    SnakeBody1X = deadX;
    SnakeBody1Y = deadY;
    SnakeBody2X = deadX;
    SnakeBody2Y = deadY;
    SnakeBody3X = deadX;
    SnakeBody3Y = deadY;
    SnakeBody4X = deadX;
    SnakeBody4Y = deadY;
  }
    public void reset() {
    health = 350;
    SnakeHeadX = width/2;
    SnakeHeadY = height/2;
  }
}
class Sword {

  float xneoSlow = .01f;
  float x = 100;
  float y = height/2;
  float attackRang =10;

  float attackRadius=175;

  float health = 200;

  int deadX = 1500;
  int deadY = 1500;

  int bossID = 3;
  int power = 20;

  float attackTime;
  float attackStance;


  boolean killZone;
  boolean inRange;

  int otherColor = 181;
  PImage sam = loadImage("SamAtk.png");


  public void drawSword() {

    //rect (x- 45, y- 75, 90, 150);//area of the samuri
    imageMode (CENTER);
    image(sam, x-15, y);
    fill(255, 0, 0);
    rect(10, height-30, health, 20);
  }

  public void updateSword() {

    x = x * (1 - xneoSlow)+ james.x * xneoSlow;
    y = y * (1 - xneoSlow)+ james.y * xneoSlow;

    float inReach = dist(x, y, james.x, james.y);

    if (inReach < 60+ attackRang) {//this number is half the sum of the player size and Sword buss size plus AttackRange
      inRange = true;
    }

    if (inRange ==true) {
      xneoSlow = 0; 
      attackStance = 20;
      attackTime++;
      attackStance++;
      if (attackStance>=180) {
        sam = loadImage("SamAtk.png");
      }else{
        sam = loadImage("SamStill.png");
      }
      /*if (attackStance<180 && attackStance>=20) {
        
      }*/
      /*if (attackStance>=190) {
        attackStance = attackTime;
      }*/
      if (attackTime==180) {/// && attack timer is up) {
        killZone = true;
        attackTime = 0;
      }


      if (attackTime<=0) {
        inRange =false;
        
      }
    } else {
      xneoSlow = .01f; 
      otherColor =181;
      attackTime = 0;
      attackStance = 0;
    }
  }

  public void clearBody() {
    x = deadX;
    y = deadY;
  }  
  public void reset() {
    health = 100;
    x = 100;
    y = height/2;
    inRange = false;
    sam = loadImage("SamStill.png");
    
  }
}
  public void settings() {  size(750, 500); }
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Game_Jam_Boss_Dungeon" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
